
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《移动App测试实战》——2.2　App UI层面的自动化 / iVAN</title>

    <meta name="description" content="《移动App测试实战》——2.2　App UI层面的自动化 2.2 App UI层面的自动化 除了上面介绍的基于接口的自动化,App UI层面的自动化也是一个重要的自动化技术.可以帮助快速地进行App功能的回归.考虑到功能的变动和维护的代价,实际中投入产出比较高的方式是针对相对稳定的功能进行快速的回归.也可以和后面讨论的持续集成结合,做新构建的验证.除了功能的自动化验证之外,UI自动化技术还有一些其他的价值,比如第4章专项测试中介绍了使用UI自动化技术和云测试平台来构造一套高效的兼容性测试方案,以及基于模糊测试思路和UI自动化建立的App稳定性测试平台.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《移动App测试实战》——2.2　App UI层面的自动化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>2.2　App UI层面的自动化</h3>
<p>除了上面介绍的基于接口的自动化，App UI层面的自动化也是一个重要的自动化技术。可以帮助快速地进行App功能的回归。考虑到功能的变动和维护的代价，实际中投入产出比较高的方式是针对相对稳定的功能进行快速的回归。也可以和后面讨论的持续集成结合，做新构建的验证。除了功能的自动化验证之外，UI自动化技术还有一些其他的价值，比如第4章专项测试中介绍了使用UI自动化技术和云测试平台来构造一套高效的兼容性测试方案，以及基于模糊测试思路和UI自动化建立的App稳定性测试平台。这些都是以App UI自动化技术为前提的。<br />
另外，需要指出的是，对于UI自动化应该有一个合理的期望。很多刚接触App测试的人或者不了解App UI自动化的管理人员，可能提起App的测试技术，觉得最主要的就是App的自动化，而主要讨论的就是UI的自动化技术。其实在经历过一些大的项目之后，观念可能会有些不同。基于目前多个团队的实践来看，如果对于一个在快速发展中的App，UI自动化可能更适合一些基础功能的回归，而不是替代手工的功能测试，特别是对于新的功能点。<br />
接下来讨论如何进行App UI的自动化测试，包括Android和iOS的做法。</p>
<h4>2.2.1　Android的UI自动化技术</h4>
<p>本节介绍Android UI自动化测试的一些基本的实现方式。由于各个项目的产品特性不同，这里不涉及UI自动化框架的封装。</p>
<h4>2.2.1.1　UI Automator Viewer</h4>
<p>在进行Android UI自动化测试之前，作为测试人员，应当了解待测App的UI，包括使用了哪些控件、控件的类名、控件的id，等等。获知这些信息之后才能写测试脚本进行自动化测试。<br />
Android SDK提供了一个UI Automator Viewer工具来帮助我们获取这些信息。（需要安装Android SDK Tools、Revision 21或以上，Android SDK Platform、API 16或以上）这个工具提供了一个可视化界面展示当前设备上的各个控件的属性。按照下列步骤使用这个工具：<br />
链接Android设备到计算机。<br />
打开/tools/。<br />
运行命令：uiautomatorviewer<br />
点击“Device Screenshot”按钮，鼠标悬停到某一UI元素上面即可查看对应控件的详细属性，如图2-16所示。<br /><a href="https://yqfile.alicdn.com/c2d428044beb6d49f0ab6196a67bf5ff54b4e77d.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2MyZDQyODA0NGJlYjZkNDlmMGFiNjE5NmE2N2JmNWZmNTRiNGU3N2QucG5n.jpg"></a></p>
<p>注意，如果你在计算机上连接了多个设备，在运行UI Automator Viewer前需要通过设置环境变量指定需要查看的UI设备。具体方法如下：<br />
通过命令 adb devices找出设备序列号。<br />
设置环境变量。<br />
Windows<br />
　　　 set ANDROID_SERIAL=&lt;上一步获取的设备序列号&gt;<br />
Linux<br />
　　　 export ANDROID_SERIAL=&lt;上一步获取的设备序列号&gt;<br />
此外，UI Automator Viewer还提供了一个功能，可以查看UIAutomator测试框架可能不支持的控件。只需要在界面上点击“Toggle NAF Nodes”按钮（右上方感叹号标记的按钮）即可查看。如果在使用UIAutomator过程中发现某个控件不能被自动化驱动，可以对照UI Automator Viewer工具的结果排查问题。<br />
在熟悉了待测App的UI以后，我们需要选择一项或者多项测试方法来进行UI自动化测试。Android的UI自动化测试方法从技术角度来说，大致可以分为以下几种：</p>
<pre><code>Instrumentation。
UIAutomator。```
 基于Instrumentation/ UIAutomator的封装。
基于系统事件的自动化测试。
基于图像识别的自动化测试。
下面分别介绍这几种方法。
####2.2.1.2　Android JUnit测试
Instrumentation和UIAutomator都是基于JUnit的，所以在介绍它们之前，先以Android Studio 1.0为例，介绍如何进行Android的JUnit测试。
1）我们需要在项目源代码目录下创建一个包和测试类，如图2-17所示。

这个测试的代码很简单，判断变量1和变量2是否相等，如果不相等，断言出错。当然运行后的结果必然是出错。这里需要注意，由于是基于Junit，测试方法名字必须以test开头，否则JUnit无法辨识。
2）点击Run-&gt;Edit Configurations。在弹出窗口上点击左上角的“Add New Configurations”按钮（绿色十字图标）。选择Android Tests，如图2-18所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/0ec4cbf0ad17d8ef8f3a09493293df6fec6b6fbf.png" width="" height=""&gt;
&lt;/div&gt;

3）按图2-19的配置设置新建的测试。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/ce9d40308cb67ee649e2a408b1b42f6d50095ac9.png" width="" height=""&gt;
&lt;/div&gt;

其中Modules为源代码所在的Module。Test部分可以自由设置寻找测试类的范围，这里我们手动指定了测试的类。
4）在工具条上选择刚才新建的测试并点击运行，如图2-20所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/518f264a3b54d2339aed86d88056d2e10415a952.png" width="" height=""&gt;
&lt;/div&gt;

5）选择设备后等待执行结果，最后结果如图2-21所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/739b7d94c419dba1a06bef62dcadcb39ba64e977.png" width="" height=""&gt;
&lt;/div&gt;

从左边栏可以看到哪个测试方法出错，从右边栏可以看详细的调用栈。经过上面的步骤我们已经可以对App进行单元测试了。只需在测试类中引用相应的待测试类并调用其方法即可。
1. Instrumentation测试框架
Instrumentation可用来进行黑盒和白盒测试，是谷歌早期推出的UI自动化测试框架，所以向后兼容性最好，可以用来测试安装在低版本的Android操作系统上的App。但相对来说，对使用此方法的测试人员的技术要求较高。主要缺陷是此方法只能用来测试单个App，涉及跨App交互的情况此方法不能支持。（例如，测试场景为：点击App A上的一个按钮将导致App B的界面展现到屏幕上，再点击App B上的一个按钮后进行断言判断。）
需要使用Instrumentation来进行UI自动化测试时。我们只需修改前面JUnit测试部分的测试类的代码即可，其他步骤都相同。
一个简单的使用Instrumentation进行UI自动化测试的测试类例子如下：
</code></pre>
<p>public class MyTest extends ActivityInstrumentationTestCase2 {<br />
 SettingsActivity mMyActivity;<br />
 protected void setUp() throws Exception {<br />
     super.setUp();<br />
      mMyActivity = getActivity();<br />
 }<br />
 protected void tearDown() throws Exception {  super.tearDown();}<br />
 public MyTest() {<br />
     super(SettingsActivity.class);<br />
 }</p>
<p>public void testCase1()<br />
 {<br />
   ActionBar mMyBar=  mMyActivity.getActionBar();<br />
   String title= mMyBar.getTitle().toString();<br />
   assertEquals(title，"My Application");<br />
 }<br />
}```<br />
我们的测试类需要继承ActivityInstrumentationTestCase2，T为待测试的Activity类型。有两个方法值得关注，一个是setUp方法。这个方法在测试开始的时候会被调用一次。我们可以在这个方法中进行初始化操作。上述代码在这个方法中获取了当前Activity对象的引用。另外一个方法是tearDown方法。这个方法在测试结束的时候会被调用一次。如有需要，我们可以在这个方法中添加代码。<br />
跟之前的JUnit测试类一样，我们的测试方法需要以test开头。在测试方法testCase1中，我们获取页面头部的文字描述，进行了校验。当页面标题不是“My Application”的时候，此测试失败。<br />
上面的代码只是一个简单的例子，我们可以做更多的事情，例如使用Activity类的findViewById方法获取需要的控件并做一些操作，如按钮点击，给输入框添加输入等。在此不一一赘述。<br />
2. UIAutomator测试框架<br />
UIAutomator是谷歌新推出的UI自动化测试框架，需要API level 16和以上的操作系统才能使用。使用它能够测试跨App交互的场景，但是它也有缺点。除了兼容性外，对一些控件也很难定位到。其中最大的缺点是不支持WebView的自动化测试。如果你的App中大量使用了WebView，并且需要对其进行UI自动化测试，那么你可能不得不选择Instrumentation。<br />
下面以Android Studio 1.0为例说明如何进行UIAutomator自动化测试：<br />
1）在\platforms\android-XX下面找到uiautomator.jar。<br />
2）将uiautomator.jar复制到项目的app/libs目录下。<br />
3）测试项目Module的依赖项增加libs下的所有jar：</p>
<pre><code>dependencies {
    compile fileTree(include: ['*.jar']， dir: 'libs')
    compile 'com.android.support:support-v4:21.0.3'
}```
4）假设我们需要测试的Activity是SettingsActivity （使用Android Studio 1.0自带项目模板Settings Activity创建）。增加测试类如图2-22所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/f0bba6681a792e57d692051a8eea3813ad83985e.png" width="" height=""&gt;
&lt;/div&gt;

5）确保待测App已经安装到Android手机上。
6）修改测试类代码为：
</code></pre>
<p>public class MyTest extends UiAutomatorTestCase  {<br />
    String packageName="com.example.test.myapplication";<br />
    String activityName="SettingsActivity";<br />
    protected void setUp() throws Exception {<br />
       getUiDevice().pressHome();</p>
<pre><code>   Runtime.getRuntime().exec("am start -a android.intent.action.MAIN -n "+packageName+"/."+activityName);
   UiObject mainUi=new UiObject(new UiSelector().packageName(packageName));
   assertTrue("App not started"，mainUi.waitForExists(3000));
   super.setUp();
</code></pre>
<p>}<br />
protected void tearDown() throws Exception <br />
{<br />super.tearDown();<br />
}<br />
    public void testCase1()<br />
    {<br />
       UiObject uiToTest=new UiObject(new UiSelector().className("android.widget.CheckBox").instance(1));<br />
       try<br />
       {<br />
          uiToTest.click();<br />
          getUiDevice().waitForIdle(3000);<br />
          UiObject uiToAssert=new UiObject(new UiSelector().text("Ringtone").instance(0));<br />
          assertFalse("CheckBox not work"，uiToAssert.isEnabled());<br />
       }<br />
       catch(UiObjectNotFoundException ex)<br />
       {<br />
            assertTrue("Cannot find checkbox"，false);<br />
       }<br />
   }<br />
}```</p>
<p>与Instrumentation类似，我们可以在setUp中写初始化的代码，在tearDown中写清理工作的代码。这里我们在setUp中进行了回到主界面的操作。以此作为测试的起点。这也是通常的做法。<br />
另外，在初始化代码中，我们调用了am命令启动我们需要测试的App的Activity。这个放在初始化的目的通常是为了节省测试的时间。一些情况下，启动Activity的工作只需要一次，我们可以写很多个测试方法来测试这个启动后的Activity的不同测试点。<br />
在测试方法testCase1中，我们执行了如下的操作：<br />
寻找第二个勾选框并点击。<br />
判断Ringtone文本是否为不可用状态（外观变为灰色）。<br />
这里有一些技巧。例如getUiDevice().waitForIdle可以保证UI变更后才执行后续代码，UiObjectNotFoundException的捕捉等。<br />
7）按上面“Android的JUnit测试”描述的第6步执行后在选择设备界面时选择Cancel。因为目前Android Studio 1.0不能很好地支持UIAutomator。我们只用它来生成测试apk包。<br />
8）项目的build\outputs\apk下可以找到带有test字样的apk包，如图2-23所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRkZWIxMDY0NzA0YmRlODJlZWU0OTVjMDdiNTg5YjIwOGEzNTcyZjUucG5n.jpg"></p>
<p>9）将Android手机连接电脑，使用下列命令将apk包推送到手机上：</p>
<pre><code>adb push app-debug-test-unaligned.apk /sdcard/test.apk```
10）使用下列命令进行UI Automator 测试：
adb shell uiautomator runtest /sdcard/test.apk
11）上述命令执行完毕后观察手机，能发现UI被自动进行了操作。等待操作完成后，查看测试结果，如图2-24所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/e3a34ed41adec631fe29cb1b7d44b275ca775bba.png" width="" height=""&gt;
&lt;/div&gt;

由于篇幅所限，更具体的UIAutomator测试方法不再进行介绍。读者可参考Android官方文档进行学习。
3.基于Instrumentation/ UIAutomator的封装
除了上文提到的两个谷歌推出的原生UI自动化测试框架外，还有很多基于它们封装的UI自动化测试框架。其中Robotium、Appium是使用比较广泛的。
Robotium其实严格来说算不上是一个测试框架，它只是一个类库，提供了更友好的定位控件的方法等，在使用Instrumentation进行自动化测试时，建议使用Robotium类库提升测试效率。
Appium是一个重量级的测试框架，支持iOS和Android等平台的自动化测试，支持多语言编写测试脚本。在Android自动化测试的实现上，它也是基于Instrumentation和UIAutomator的。Appium用Ruby写的测试脚本示例如图2-25所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/634b95e0f7a18f4c3dbcd91303dc8a7a6ce4a1d5.png" width="" height=""&gt;
&lt;/div&gt;

由于篇幅所限，本书不赘述它们具体的使用方法。有兴趣的读者可以自行搜索相关的资料。
####2.2.1.3　基于系统事件的自动化测试
所有Android操作系统的输入事件都可以在进入adb shell后通过getevent获取（需要su），相关示例如图2-26所示。
这些事件都会存储在/dev/input/eventX下。每个eventX代表一个输入外设。例如触摸屏、键盘等，而输出的每一行代表一个事件，例如某个键盘按下，等等（具体每个事件的三个部分代表什么含义请参考Linux相关资料）。因此，我们可以通过解析这些文件，来实现录制的功能。测试人员可以把自己的操作录制下来，用一种数据格式记录。
那么怎么回放录制的测试脚本呢？我们可以解析录制的数据，并在adb shell下使用sendevent命令向指定外设一个个发送事件，也可以在adb shell下用input keyevent命令来做。例如，在将Android手机连接计算机后打开一个记事本类程序，进入adb shell，执行：

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/454621741fe779628747aeb664f6146527f56c3d.png" width="" height=""&gt;
&lt;/div&gt;

</code></pre>
<p>　Input keyevent 34```<br />
你会发现效果等同于输入一个F键。<br />
基于系统的事件无法对界面上的元素做判断，只能进行一些驱动类型的工作。因此这个方法不能单独使用来进行自动化测试。断言部分需要配合Instrumentation/UIAutomator。<br />
此方法的缺陷是：<br />
不同的设备有不同的分辨率。在A设备下录制的脚本在B设备下执行可能会产生问题。<br />
不同设备的eventX可能代表不同外设。<br />
这些都是在使用这个方法进行自动化测试的时候需要考虑的问题。</p>
<h4>2.2.1.4　基于图像识别的自动化测试</h4>
<p>近年来图像识别技术有了一定的发展。因此测试人员也开始研究是否可以将此技术应用到自动化测试中。简单的想法是，如果一个App的各个元素外观变化不大，而位置变化较为频繁，或者内部实现（例如UI控件类的变化）改变较为频繁，使用图像识别来写测试脚本的稳定性可能会较高。另外如果断言是基于图像的，那么使用图像识别技术来做自动化测试更为自然和方便。<br />
测试方法举例：<br />
1）测试人员写测试脚本，指定需要操作哪些元素（指定图片相关的特征），并说明怎么操作。<br />
2）使用adb screencap命令截图。<br />
3）使用图像识别技术来识别出各个元素的位置。<br />
4）解析测试脚本，找出下个操作步骤。如果测试结束，则退出生成报告。<br />
5）采用某方法进行相应的操作（通过系统事件、机器人手臂等方式驱动），或者进行基于图像识别的断言。<br />
6）返回步骤2）。<br />
但是由于使用此方法的优势只在特定场景能够体现，局限性较大，再加上图像识别准确率的问题，目前还没有被广泛接受和应用的测试框架出现。在此提及也是抛砖引玉，希望有一天能够有一个出色的基于图像识别的Android测试框架问世。</p>
<h4>2.2.2　iOS的UI自动化技术</h4>
<p>关于iOS的UI自动化，这里结合实例介绍两个方面的内容，一个是基于Instrument的UI自动化，另一个是目前比较常用的Appium框架。</p>
<h4>2.2.2.1　基于Instrument的iOS UI自动化</h4>
<p>对于iOS的UI自动化，Instrument 提供了最基本的自动化测试功能。我们可以通过Automation工具实现基本的自动化测试需求。该工具支持真机和模拟器两种测试方式：<br />
模拟器：执行速度快，无须证书， 测试门槛较低， 但对于一些特定功能如相机、跳转就无能为力了。<br />
真机：App的所有功能均能自动化实现，但需调试证书，且执行效率低。<br />
下面用一个示例介绍整个使用过程。<br />
1. 开始使用Automation<br />
下面我们以Xcode 6为例， 介绍使用Automation的步骤。<br />
1）选择要测试的target， 选定要编译安装的平台，若在真机上测试就选择真机设备，同时指定好调试证书及对应的provision文件。若在模拟器上测试就选择模拟器环境，我们这边指定iPhone6模拟器，如图2-27所示。<br />
2）在刚才选择界面，点击Edit Scheme，指定Profile选项以Debug模式编译，点击关闭，如图2-28所示。<br />
3）点击Product菜单下的Profile选项来编译项目工程，如图2-29所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2IwN2NiMDJlYmYxMWQzNjEwMDQxODQ3ZmFkNDQyNTE2YzUzMWYxYzQucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRkOTAxMjM0NGUzMzdhNDU5NjMwOWY4NjI1NzMwYjZhZjhlNzM2ODgucG5n.jpg"></p>
<p>4）等待编译完成后，弹出Instrument界面，选择Automation，如图2-30所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2QyZGRlOGYyNjg0MGFlNmJmYTE5MTI2MzY5NTJlMmQxNzY3YzM3ZDUucG5n.jpg"></p>
<p>5）系统自动选择模拟器中的测试App，如果要改成真机运行，修改界面上方的测试平台至真实设备，选择相应的App即可，如图2-31所示。<br />
2. 录制脚本<br />
我们可以通过录制的方式生成测试脚本，切换到Script界面，点击下方的录制按钮，App在模拟器中就启动了，我们对App的操作，就会被自动录制成回放脚本，录制完成后，点击终止按钮，结束录制。点击运行按钮，就可以执行回放刚才录制的操作了，如图2-32所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzA1OTU4NzAyZjJlYmNlNjVlNmI4MWVkNTczYmM5N2U4MjZmYmM3YzIucG5n.jpg"></p>
<ol>
<li>编写自己的脚本<br />
录制的方式虽然很方便，但是缺乏灵活性。大多数时候，我们需要自己编写脚本。我们的测试App是一个很简单的登录界面，输入用户名panxiaoming，密码:Ilovetest，就会登录成功，弹出一个欢迎界面，如图2-33所示。</li>
</ol>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2JjMGMzODBiOTZjY2NhMmEzOWY2ZGRhNWU3MzZjODgxZGZhOTc4YjYucG5n.jpg"></p>
<p>如果输入错误的密码，会提示错误信息，如图2-34所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRjNGM4M2MyZTNiNzY4YzVhYTMwZjhhZjM3NDk5OWNhYzc5N2RlMTIucG5n.jpg"></p>
<p>输入正确的密码，提示欢迎信息，如图2-35所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzFkZTdjMWRiMjYwNGU0MWY0ZjFkMmIxYjg0MDgzM2YwODI4NjYyNjQucG5n.jpg"></p>
<p>我们可以通过logElementTree的方法查看App的UI元素布局。点击运行，在Editor Log界面中查看这些UI元素，如图2-36所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzNlNzM3YzE2NjJjY2VkMzI4ZmJiMThmMmFiMTFiNTYxZmY0MThlZmEucG5n.jpg"></p>
<p>Editor Log很有用，在这里可以查看脚本中所有的log信息以及断言结果，同时它会自动记录点击操作和一些其他的操作，同时还有截图，方便查看。<br />
于是我们就可以编写一个正常登录的测试脚本，脚本如图2-37所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzhkZjBlMTljZDkyYzQwYTExODEyNGU3YTZmNmM0MTM0YmFmYzRmZjUucG5n.jpg"></p>
<p>执行结果如图2-38所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzRmMWUxZTg2MGNjMjQ1MGE0ZjU0NzZkOTcyYTgwMWM0NDc3MmFhNGIucG5n.jpg"></p>
<p>我们看到在自己编写的脚本中加入逻辑和判断，使得脚本的可靠性更强，同时log信息可以帮助我们去分析定位问题，这种方式要比简单录制强上不少，脚本的语句类似JavaScript，可以到苹果官网查看具体语法和API。<br />
4. Automation的高级用法<br />
我们完全可以通过shell脚本去驱动执行Automation的测试用例， 通过定时执行shell脚本来完成我们的自动化测试任务，具体方法如下：</p>
<pre><code>instruments -t &lt;automationTracetemplate路径&gt; &lt;模拟器App路径&gt; -e UIASCRIPT &lt;testcase路径&gt;```
我们只需要在自动化测试代码中使用performTaskWithPathArgumentsTimeout的方法把断言执行结果通过shell脚本写到外部文件中，就可以查看所有case的执行结果了。
5. Automation的总结
Instrument的Automation总体来说还是比较强大的，首先它不需要对App作任何修改、插桩，保证了App的原生功能。其次对iOS的控件支持非常好，同时支持暂停、截图等一系列功能，基本上能够满足我们对自动化测试的需要。不过它也有不少缺点，首先它没有case管理概念，其次是它的扩展性不是很好，还有就是它的执行经常会中断。
####2.2.2.2　自动化测试框架之Appium
Appium是当前比较流行的一个自动化测试框架。它是一个开源的自动化测试框架，支持跨平台，支持原生和混合开发，支持真机和模拟器。它是一个C/S结构的设计，底层是基于iOS的UIAutomation， 它的特点是：
无需任何驱动桩的插入，可直接操作原App。
case支持多种语言。
内含丰富的API，支持更多的手机端的操作。
支持各种测试框架。
下面简单介绍一下Appium在模拟器上的使用方法:
1）先到bitbucket.org/appium/appium.app/downloads/ 下载appium.app程序，记得下载OS X的版本。
2）安装该App到你的Mac机器上。
3）启动App，界面显示如图2-39所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/32f55f81d896256a39156a719b105d8d8c5fcc67.png" width="" height=""&gt;
&lt;/div&gt;

4）首先我们需要检测当前环境，点击 ，Appium会自动帮你检测当前环境，是否有需要安装的依赖的工具。如果环境没问题会显示如图2-40所示界面（这里因为没有安装Android的环境，所以报错，可以忽略）。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/0d014f74c803fbb9e25dae1af5416dbec38e2a56.png" width="" height=""&gt;
&lt;/div&gt;

5）因为我们需要测试iOS的App，所以应勾选苹果的图标，点击该图标，进入iOS的设置界面，如图2-41所示。在这里设置我们要测试的项目工程编译完的.app文件的路径，以及模拟器和iOS版本。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/10ec0083f5a366d044dcabcc4360856b575ee7b8.png" width="" height=""&gt;
&lt;/div&gt;

6）点击  进入常规设置，如图2-42所示，在这里设置Appium Server的地址和端口信息，并设置本地地址和默认端口，同时勾选回调的地址和端口。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/51b954ba4b076fffd58b999747f07f7f16c522de.png" width="" height=""&gt;
&lt;/div&gt;

7）点击Lauch就可以启动Appium Server了。点击  就可以去捕获UI控件了，我们可以看到模拟器被启动了，同时之前设置的App也被启动了。
8）在控件捕获界面，我们可以通过点击右边的截屏来获取控件的xpath，如图2-43所示。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/b066235eb67cfdf68a43b78a9fb4e27e3924385a.png" width="" height=""&gt;
&lt;/div&gt;

9）同时可以点击录制，自动生成操作代码，如图2-44所示。录制界面支持预设的手势操作。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/1f7b0fd50794d1bf22b32c3371cd63481be2a1d2.png" width="" height=""&gt;
&lt;/div&gt;

10）我们可以用自己熟悉的语言编写自己的测试用例，然后去执行这些用例，图2-45为在Eclipse里执行Java的测试用例。
本节大致介绍了Appium的基本功能和使用方法，由于篇幅有限，这里就不作详细介绍了。

&lt;div style="text-align: center"&gt;&lt;img src="https://yqfile.alicdn.com/a816e26ffb00e6fe28be5c5cdcdb146825dbb391.png" width="" height=""&gt;
&lt;/div&gt;
</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 22:27:02</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/shell/" title="shell">shell</a>, <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>, <a href="https://www.iamivan.net/tag/%e8%87%aa%e5%8a%a8%e5%8c%96%e6%b5%8b%e8%af%95/" title="自动化测试">自动化测试</a>, <a href="https://www.iamivan.net/tag/%e5%9b%be%e5%83%8f%e8%af%86%e5%88%ab/" title="图像识别">图像识别</a>, <a href="https://www.iamivan.net/tag/activity/" title="activity">activity</a>, <a href="https://www.iamivan.net/tag/uiautomator/" title="uiautomator">uiautomator</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《移动App测试实战》——2.2　App UI层面的自动化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba7JNNp.html" rel="bookmark">《移动App测试实战》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前 言 现在已经是移动互联网的时代,借助手机等移动设备,人们可以完成资讯的获取.社交.游戏,以及日常生活的各种应用,甚至很多工作的开展.有很多新兴的移动互联网公司在崛起,也有很多传统的IT公司在转型,更有大量传统行业的企业在借助移动互联网拓展自己的业务.对IT技术人员而言,这是一个非常好的时代,有大量的工作机会,因为有大量的移动互联网相关系统的研发需求.当然,这也意味着有很多新的技术和方法要去学习.有很多的研发人员快速转型到移动互联网领域,有大量的移动互联网产品被开发出来.在这个过程中,也会面临			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDXWkLz.html" rel="bookmark">《精通移动App测试实战：技术、工具和案例》一第1章　Android系统基础内容介绍1&period;1　Android系统介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 Android系统基础内容介绍 精通移动App测试实战:技术.工具和案例工欲善其事必先利其器,因为本书主要是针对移动平台讲解测试方面的内容,所以对移动平台目前主流的Android系统有一个了解十分必要,下面我们就一起来了解一下这个操作系统相关的知识内容. 1.1 Android系统介绍 Android一词的原意指&quot;机器人&quot;,同时也是Google于2007年11月5日宣布的基于Linux平台的开源手机操作系统的名称,该平台由操作系统.中间件.用户界面和应用软件组成. Androi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR8Zl3z.html" rel="bookmark">《精通移动App测试实战：技术、工具和案例》一第2章　JUnit框架基础2&period;1　JUnit框架介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 JUnit框架基础 精通移动App测试实战:技术.工具和案例 2.1 JUnit框架介绍 瀑布模型是最早出现的软件开发模型,如图2-1所示.该开发模型可以说在软件工程中占有重要的地位,它提供了软件开发的基本框架.其过程是从上一项活动接收该项活动的工作对象作为输入,利用这一输入实施该项活动应完成的内容,给出该项活动的工作成果,并作为输出传给下一项活动.同时评审该项活动的实施,若确认,则继续下一项活动:否则返回前面,甚至更前面的活动.对于经常变化的项目而言,瀑布模型毫无价值.然而,时至今日,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKLPvZM.html" rel="bookmark">《移动App测试实战》&mdash;&mdash;2&period;3　本章小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 本章小结 本章我们介绍一种基于开源工具的轻量级接口自动化的实践方法,并结合实例分别介绍了Android和iOS的App UI自动化测试的一些技术方案,可以作为无线测试团队开展自动化测试方面的一些参考.这两种方法看似独立,其实可以互为补充,甚至可以结合起来用.因为UI自动化测试中的断言通常是对UI层面的元素做出的,例如判断是否界面上某个文本控件的文本符合要求等.但是对于一些特殊情况,例如操作控件后UI并无可提供断言的变化,而是对后台的数据产生了变化,我们需要有对非UI进行断言的方法,这样对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQl4Wp.html" rel="bookmark">《精通移动App测试实战：技术、工具和案例》一1&period;7　创建一个Android项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.7 创建一个Android项目 前面已经完成了Android开发环境的搭建工作,现在就让我们一起来编写一个简单的Android程序.这里我们要实现一个两个整型数字相加的程序. 1.7.1 创建一个新的Android项目 启动Eclipse,单击&quot;File &gt; New &gt; Android Application Project&quot;菜单项,如图1-42所示. 1.7.2 如何填写Android项目信息 在弹出的图1-43所示界面中,&quot;Application Name			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDmlKz.html" rel="bookmark">《移动App测试实战》&mdash;&mdash;2&period;1　轻量接口自动化测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1 轻量接口自动化测试 无论Web互联网的产品还是移动互联网的产品都必须依赖大量的后台接口提供的服务,有很多的业务逻辑都是放在后台来处理的,所以非常有必要对这部分逻辑来做测试验证.技术方案上,也可以模拟用户的UI操作,从界面上发起相关的请求.但是实际中,会发现这样的做法效率不高而且稳定性不够,开发和维护的代价也比较大.针对这部分的测试,最直接的方式还是从接口层面发起请求来验证. 就目前观察,对于一些比较稳定的基础性组件,比如底层平台.API.SDK等,或者功能通用性高的产品,比如防火墙.邮件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkw8a5p.html" rel="bookmark">《精通移动App测试实战：技术、工具和案例》一2&period;3　应用JUnit对Android项目进行单元测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.3 应用JUnit对Android项目进行单元测试 2.3.1 JUnit基于Android项目TestCase的应用 如果我们对基于Android系统项目开发有一定了解的话,相信一定能看出来,其核心代码是计算两个整数相加的函数.我们做单元测试当然也挑选其最核心的函数来进行测试.可以按照如下的步骤来创建一个基于Android项目的测试用例(TestCase). 第一步:选中&quot;CalculatorOfTwoNum&quot;项目下的&quot;src&quot;目录中的&quot;com.yu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5RdaBz.html" rel="bookmark">《移动App测试实战》&mdash;&mdash;1&period;2　测试用例设计和评审</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 测试用例设计和评审 测试人员的一个基本工作,或者说是基本功,就是测试用例的编写.对于一些快速迭代的互联网产品,关于是否需要编写测试用例,也有一些讨论和争论. 就我们的观念,觉得还是需要,特别是对于App这样的产品,很多功能有一定的稳定性.类比来说,测试用例相当于电影的剧本,有场景.动作.台词,规划出一个基本的框架.测试用例也是一样,针对什么功能,在什么情况和使用场景下,做什么操作,用什么数据,期望有什么样的结果,进而和实际结果对比判断是否合理. 如果完全没有这样的剧本,测试会比较盲目,更			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdvEmAb.html" rel="bookmark">《精通移动App测试实战：技术、工具和案例》一2&period;2　JUnit在Android开发中的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.2 JUnit在Android开发中的应用 2.2.1 单元测试的重要性 前面我们提到了单元测试,那么什么叫单元测试呢?单元测试(Unit Testing),是指对软件中的最小可测试单元进行的检查和验证.对于单元测试中单元的含义,一般来说,要根据实际情况去判定其具体含义,如在Java中单元指一个类,在C语言里单元指一个函数等.单元测试是在软件开发过程中要进行的最低级别的测试活动,软件的独立单元将在与程序的其他部分相隔离的情况下进行测试.通常,我们在编写大型应用系统的时候,都要写成千上万个方法			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGqkeM.html" rel="bookmark" class="title">老生常谈外链 站长要做到对症下药</a>
					<div>
						对于搜索引擎(这里泛指百度)来说,相信大家都熟知外链为王这种说法了,的确,在网站结构层次正常和内容坚持原创更新的情况下,外链对于网站的排名和流量的高低都有着很重要的作用,几乎成败都要依托外链了.我学习 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKVKmM.html" rel="bookmark" class="title">HBase一次慢查询请求的问题排查与解决过程</a>
					<div>
						最近HBase集群遇到过一次慢查询请求的问题,下面是对这一问题的具体描述及排查解决过程. 1. 发现问题 项目中有一张HBase表,每天凌晨以后会集中批量导入一批数据,导入数据量很大,在千万到亿的量级 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxP2mPM.html" rel="bookmark" class="title">迅雷极速版v1&period;0&period;2&period;24的功能变化：去掉一些插件广告</a>
					<div>
						迅雷极速版3月25日更新1.0.2.24,优化繁复的安装过程,默认给你最智能的设置,告别痛苦,极速启动:P2P加速模块常驻,优先插队加速,隐藏一些高级功能,去掉了一些插件广告,力求做最懂您的迅雷. 功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1Ra99p.html" rel="bookmark" class="title">在Struts 2&period;0中国际化&lpar;i18n&rpar;您的应用程序</a>
					<div>
						国际化是商业系统中不可或缺的一部分,所以无论您学习的是什么Web框架,它都是必须掌握的技能. 其实,Struts 1.x在此部分已经做得相当不错了.它极大地简化了我们程序员在做国际化时所需的工作,例如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91OlXM.html" rel="bookmark" class="title">wps怎么关闭热点</a>
					<div>
						  1.大家可以看到弹出的热点我们点击&quot;设置&quot;会出现&quot;一周后显示&quot;或者&quot;当天显示&quot;这里设置最多我们一个星期不见到它,过了一个星期它又会回来. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZV73b.html" rel="bookmark" class="title">如何在win8系统中刻录光盘？</a>
					<div>
						  虽然新系统win10已经取消了光盘刻录和光盘播放的功能,但是在占有市场主导地位的win7系统和win8系统中,这个刻录的功能还是存在的,其实,在市场中,还是有不少的行业仍然需要这个功能,那么大家知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badvEnz.html" rel="bookmark" class="title">Win7系统下如何关闭无响应程序的方法</a>
					<div>
						  在使用Windows 7系统的过程中,难免会遇到无响应程序,这样的程序无法操作也无法关闭,可通过任务管理器结束进程,但是对于菜鸟来说,那么多的进程,不知道哪个才是,如果结束错了,可能又会引发其他问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8y5Rb.html" rel="bookmark" class="title">EATX主板是什么</a>
					<div>
						  EATX主板是Extended ATX的缩写,主要用于Rackmount服务器系统.它通常用于双处理器和标准 ATX 主板上无法胜任的服务器上,尺寸为12 × 13英寸(305mm × 330 m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o0r0b.html" rel="bookmark" class="title">不能通过无线路由器登录连接VPN</a>
					<div>
						  无线路由器与VPN服务器连接出现问题,不能通过无线路由登录连接IPSecVPN. 要解决VPN的连接问题,首先要下载和更新路由器的Firmware.如果更新了Firmware问题没有解决,可以打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7v50M.html" rel="bookmark" class="title">程序员的核心价值</a>
					<div>
						问题描述 今天和朋友一起上班的路上,他是设计总监,问我:你觉得程序员的核心价值是什么,或者说你觉得程序员如何体现自己的优势?如果你身边的PM.设计师.前端开发人员比较强势,你如何才能不沦为一个埋头敲代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAr3Zvp.html" rel="bookmark" class="title">hql语句只能查询出数据库里面的第一条数据</a>
					<div>
						问题描述 hql语句只能查询出数据库里面的第一条数据 dao层 //查询所有的信息 public List&lt;Stock&gt; getAll() { String hql = &quot;&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32yvmz.html" rel="bookmark" class="title">pdsh、ClusterSSH和mussh集群管理软件</a>
					<div>
						我是想把 /etc/hosts 文件 分发到 10.205.10.11至20机器上 安装命令 sudo yum -y install clusterssh pdsh pdsh-rcmd-ssh pds ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVdA6b.html" rel="bookmark" class="title">Mysql导入&period;sql文件出错</a>
					<div>
						问题描述 Mysql导入.sql文件出错 mysql导入sql文件时老是提示错误,请问各位高手该怎么解决? 解决方案 那最长的串右侧没有单引号 '注意用括起来' 解决方案二: 单引号要成双成对.一一对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWlvOp.html" rel="bookmark" class="title">必须来GeekPwn的十大理由</a>
					<div>
						距离10月24日不到两周的时间了,GeekPwn 2015将在上海揭开神秘面纱.相信大家对这个安全圈的狂欢大Party也是充满了好奇,现场将有机会与哪些偶像大神亲密邂逅?哪些神奇小子会现场大&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkw80rp.html" rel="bookmark" class="title">IFTTT在开发环境中使用Docker的经验</a>
					<div>
						本文讲的是IFTTT在开发环境中使用Docker的经验,[编者的话]IFTTT是&quot;if this then that&quot;的缩写,事实上是让你的网络行为能够引发连锁反应.让你使用更为方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAwwOM.html" rel="bookmark" class="title">ios-  iOS  Button点击问题</a>
					<div>
						问题描述 iOS Button点击问题 button上有张图片.有个显示数字的label 怎样实现在没点击时 图片和数字都显示灰色.当点击时图片和数字都变成红色,切数字数加一 解决方案 我按照理解你的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydOBvb.html" rel="bookmark" class="title">OpenStack：持续创新，永无止境</a>
					<div>
						9月初,云计算开源产业联盟.中国信息通信研究院共同发布首批通过可信云私有云开源解决方案认证的七个厂家.此次参评的解决方案主要聚焦在OpenStack技术架构,表明了国内产业联盟及科研组织对OpenSt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLeV6p.html" rel="bookmark" class="title">为什么项目加不了引用？</a>
					<div>
						问题描述 对c#不熟,但是现在反汇编一个程序后,语法错误消除了,但是项目中引用了DLL,我想在项目里把DLL文件加进去,结果新加的DLL出现黄色问号,显示假如不成功,但是被加的DLL可以反汇编呢. 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rg50z.html" rel="bookmark" class="title">传统电视厂商需要互联网模式</a>
					<div>
						7月3日,以互联网模式销售的乐视超级电视真的卖火了,1万台X60用49分钟售罄,销售额超7500万元.这可能真的是创造了大尺寸电视瞬时销量的记录.尽管传统电视厂商前几日还在公开质疑乐视的物流配送和售后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeokW7M.html" rel="bookmark" class="title">php编程工具vim的快捷键指南</a>
					<div>
						为了方便大家使用vim,并使得新手能够迅速的上手,特从网上总结了vim的一些常用快捷键,分享给大家: vi常用快捷键光标控制命令 命令&amp;http://www.aliyun.com/zixun/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLeEnM.html" rel="bookmark" class="title">关于json返回的数据为什么取不到啊</a>
					<div>
						问题描述 我在ashx中将list转为json后,取不到值啊,这是返回的data值:[{&quot;id&quot;:&quot;newid&quot;,&quot;name&quot;:null,& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOngV5p.html" rel="bookmark" class="title">Ajax提交与传统表单提交的区别说明&lowbar;javascript技巧</a>
					<div>
						Ajax提交是通过js来提交请求,请求与响应均由js引擎来处理,页面不会刷新,用户感觉不到实际上浏览器发出了请求.比如说我们希望网页总是显示最新的新闻,而又不想老是去点刷新按钮,我们就可以用Ajax机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jwavp.html" rel="bookmark" class="title">为啥用户登录不上去啊，好多用户反应这个问题，求解</a>
					<div>
						问题描述 解决方案 您好,我们这边后台监测是正常的.登陆不上是指的什么?发不出去消息还是发出去了对方收不到?直接运行的demo也是这样?方便的话导一下log我们这边帮您排查下android 环信log ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0YRX8p.html" rel="bookmark" class="title">是不是有经验的JavaEE开发者，看你json玩的6不6（上）</a>
					<div>
						刚参加工作那会儿,面临的第一个问题是: 0.如何把form表单序列化成一个json对象?序列化表单时,会遇到哪些问题? 1.如果传一个对象数组到后台?有几种实现方式? 再后来遇到的问题是: 2.str ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqmQEp.html" rel="bookmark" class="title">求一款B&sol;S模式的汽车美容维修管理软件。</a>
					<div>
						问题描述 求一款B/S模式的汽车美容维修管理软件,有朋友有的请与我联系:广西13152675443QQ:65149483Email:hms333@163.com黄先生,价格面议.(急) 解决方案 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baq1Lnb.html" rel="bookmark" class="title">Sed&amp;amp&semi;awk笔记之awk篇：快速了解Awk（三）</a>
					<div>
						上一篇中,主要介绍了awk中的一些基础概念,包括记录与字段.表达式.变量.语句等等,本篇在此基础上进一步介绍下awk中的函数. awk的函数分成数学函数.字符串函数.I/O处理函数以及用户自定义的函数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOWqx3z.html" rel="bookmark" class="title">如何对交换机进行初始化配置</a>
					<div>
						在大多数实例中,你可以从包装盒中取出任何品牌的交换机,打开电源,不用任何配置就可以让这台交换机提供你需要的连接,就像不需要管理的集线器一样.在本文中,我们将讨论你什么时候需要进行额外的配置.首先,每一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZm3Xop.html" rel="bookmark" class="title">Linux tar命令使用列子第1&sol;2页&lowbar;Linux</a>
					<div>
						    用tar建立存档     tar是&quot;tape archive&quot;(磁带存档)的简称,它出现在还没有软盘驱动器.硬盘和光盘驱动器的计算机早期阶段.那时软件的发行和备份都需要大卷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqgwgez.html" rel="bookmark" class="title">证监会出手监管&OpenCurlyDoubleQuote;余额宝们&rdquo; 互联网金融引发监管论</a>
					<div>
						近日,&quot;理财神器&quot;余额宝被推上了风口浪尖,先是被呼吁取缔,后是迎来监管紧箍咒. 昨日,证监会新闻发言人张晓军表示,为了更好地促进余额宝等互联网基金的健康 稳定发展,证监会正在研究制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjEo45z.html" rel="bookmark" class="title">云计算是数据中心的&OpenCurlyDoubleQuote;叶子&rdquo;：两者关系全解读</a>
					<div>
						随着互联网+的发展壮大,&quot;大数据时代&quot;.&quot;云计算时代&quot;一时受到热捧.那么,这究竟是谁的时代?数据中心碰上云计算,未来该如何? 一.云计算与数据中心的关系 数据中 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
